%%%%%%%%%%%%%%%%%%%
%% Matlab alapok %%
%%%%%%%%%%%%%%%%%%%
% help * % súgó a * függvényről
%% Vektorok, mátrixok megadása, alapműveletek
c = 3; % szám megadása
v = [1, 2, 3, 4, 5]; % sorvektor megadása
w = [1; 2; 3]; % oszlopvektor megadása
x = 1:100; % az [1 2 3 ... 98 99 100] vektor
y = 1:0.1:100; % az [1 1.1 1.2 1.3 ... 99.8 99.9 100] vektor
u = v'; % transzponálás
v % változó kiírása
v(2) = 5; % vektor elemének módosítása
v(2) % vektor elemének elérése
v(2:3) % vektor elemeinek elérése
v(2:3) = 6; % vektor elemeinek módosítása
v = v * c; % számmal való szorzás
v = v / 4; % számmal való osztás
v = v + 1; % vektor elemeinek számmal való növelése
v(2:end-1) % az 'end' használata 
M = [1, 2, 3; 4, 5, 6; 7, 8, 9]; % mátrix megadása
N = magic(3); % 3x3-as mátrix (bűvös négyzet)
Z = zeros(3,4); % 3x4-es mátrix nullákkal feltöltve
I = eye(3); % 3x3-as egységmátrix
x = M * w; % mátrix-vektor szorzás
P = M * N; % mátrix-mátrix szorzás
Q = M ^ 3; % négyzetes mátrix hatványozása
A = M + N; % mátrixok összege
B = M - N; % mátrixok különbsége
C = B'; % mátrix transzponáltja
C = c * C; % mátrix számmal való szorzása
B = B + c; % mátrix elemeinek számmal való növelése
Q(:) % mátrix elemeiből összeállított oszlopvektor
Q(2,3) % mátrix elemének elérése
Q(1,1:end-1) = 10; %mátrix elemeinek módosítása
Q % változó kiírása
[1 2 3 4 5] .* [2 3 4 5 6] % elemenkénti szorzás
[1 2 3; 4 5 6] .* [2 3 4; 5 6 7] % elemenkénti szorzás
[1 2 3 4 5] ./ [2 3 4 5 6] % elemenkénti osztás
[1 2 3; 4 5 6] ./ [2 3 4; 5 6 7] % elemenkénti osztás
[1 2; 3 4] .^ 3 % elemenkénti hatványozás
%% Lineáris egyenletrendszer megoldása
A = [0 1 1; 1 0 1; 1 1 0];
b = [1 1 1]';
x = A \ b % A * x = b megoldása
x = b' / A % x * A = b' megoldása
%% Függvények megadása
f = @(x) x.^2;
g = @(t,x) x + t;
%% Ha ... akkor ... különben ...
if c > 10
  m = c;
else
  m = 10;
end
%% for ciklus
c
for i = 1:10
  c = c + i;
end
c
