%%%%%%%%%%%%%%%%%%%%%%%
%% A plot használata %%
%%%%%%%%%%%%%%%%%%%%%%%
close all % ábrák bezárása
T = 0:0.1:5*pi; % felbontás beállítása
X = cos(T) .* exp(-0.1*T);
Y = sin(T) .* exp(-0.1*T);
%% Függvények és paraméteres görbék ábrázolása
figure % új ábra készítése
plot (T, X) % a grafikon kirajzolása
figure
plot (X,Y) % paraméteres görbe rajzolása
axis equal % x és y tengely arányának megtartása
%% Ábra finomhangolása 
figure
plot(T, X, 'rx--', 'Linewidth', 2) % görbe tulajdonságainak beállítása 
hold on % várakozás további görbékre
plot(T, Y, 'g-.', 'Linewidth', 2) % második görbe
hold off % nincs több görbe
title('Gorbek') % cím
xlabel('x') % x-tengely felirata
ylabel('y') % y-tengely felirata
legend('cos(t)*exp(-0.1*t)', 'sin(t)*exp(-0.1*t)') % jelmagyarázat
legend('Location', 'North') % jelmagyarázat pozícionálása
grid on % rács megjelenítése
%% Több grafikon egy ábrán
figure
subplot(2,1,1) % ábra pozicionálása 2x1-es mátrix 1. elemének helyére 
plot(X, Y, 'b:')
title 'Logaritmikus spiral'
xlabel('X')
ylabel('Y')
legend('(X(t),Y(t))')
grid on
subplot(2, 2, 3) % ábra pozicionálása 2x2-es mátrix 3. elemének helyére 
plot(T, X, 'r')
title 'cos(t)*exp(-0.1*t)'
xlabel('t')
ylabel('X')
legend('cos(t)*exp(-0.1*t)')
subplot(2, 2, 4) % ábra pozicionálása 2x2-es mátrix 4. elemének helyére 
plot(T, Y, 'm')
title 'sin(t)*exp(-0.1*t)'
xlabel('t')
ylabel('Y')
legend('sin(t)*exp(-0.1*t)')
%% 3D-s grafikon
figure
plot3(X, Y, T)
grid on
