%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% EE, IE, ETR, ITR rendszerekre %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
% u1' = -2u1 + u2 + 3
% u2' = -2u1 - 5u2 -3
% u1(0) = 3, u2(0) = -3
% oszlopvektor -> oszlopvektor
f = @(t, u) [-2 1; -2 -5] * u + [3; -3];
u_pontos = @(t) [2*exp(-3*t) + 1; -2*exp(-3*t) - 1];
t0 = 0;
T = 1;
u0 = [3; -3];
options = optimset('Display', 'off');
n = 100;
dt = (T-t0)/n;
uEE = zeros(2, n+1);
uIE = zeros(2, n+1);
uETR = zeros(2, n+1);
uITR = zeros(2, n+1);
uEE(1:2, 1) = u0;
uIE(1:2, 1) = u0;
uETR(1:2, 1) = u0;
uITR(1:2, 1) = u0;
t = zeros(1, n+1);
t(1) = t0;
for i = 1:n
  t(i+1) = t(i) + dt;
end
for i = 1:n
  uEE(1:2, i+1) = uEE(1:2, i) + dt * f(t(i), uEE(1:2, i));
end
for i = 1:n
  % u(1:2, i+1) éppen gIE nullhelye
  gIE = @(u) (u - uIE(1:2, i)) - dt * f(t(i+1), u);
  uIE(1:2, i+1) = fsolve(gIE, uIE(1:2, i), options);
end
for i = 1:n
  uuEE = uETR(1:2, i) + dt * f(t(i), uETR(1:2, i));
  uETR(1:2, i+1) = uETR(1:2, i) + dt * 0.5 * (f(t(i), uETR(1:2, i)) + f(t(i+1), uuEE));
end
for i = 1:n
  % u(1:2, i+1) éppen gITR nullhelye
  gITR = @(u) (u - uITR(1:2, i)) - dt * 0.5 * (f(t(i), uITR(1:2, i)) + f(t(i+1), u));
  uITR(1:2, i+1) = fsolve(gITR, uITR(1:2, i), options);
end
figure
hold on
plot(t, uEE, 'b')
plot(t, uIE, 'g')
plot(t, uETR, 'b-.')
plot(t, uITR, 'g-.')
plot(t, u_pontos(t), 'r')
xlabel('t')
ylabel('u')
legend('u1EE', 'u2EE', 'u1IE', 'u2IE', 'u1ETR', 'u2ETR', 'u1ITR', 'u2ITR', 'u1', 'u2')
legend('Location', 'SouthEast')
hold off
