%%%%%%%%%%%%%%%%%%%%%%%%%
%% Fázistér, attraktor %%
%%%%%%%%%%%%%%%%%%%%%%%%%
close all
% u1' = -u1 + u2 - 5
% u2' = u1^2 - 2*u2 - 5
f1 = @(t, u1, u2) -u1+u2-5;
f2 = @(t, u1, u2) u1.^2-2*u2-5;
[u1, u2] = meshgrid([-5:0.5:7], [-2:0.5:14]);
figure
hold on
quiver(u1, u2, f1(t, u1, u2), f2(t, u1, u2));
plot(-3, 2, 'ro')
plot(5, 10, 'ro')
xlabel('u1')
ylabel('u2')
hold off
% Van der Pol
% u" - 8.53*(1-u^2)*u' + u - 1.2*sin(pi/10*t) = 0
% u1 = u, u2 = u'
f = @(t, u) [u(2); (1-u(1)^2)*u(2)-u(1)];
u0 = [1; 1];
u1 = [2.5; 1];
u2 = [10; 3];
t0 = 15;
t1 = 10;
t2 = 50;
[t, v0] = ode45(f, [0, t0], u0);
[t, v1] = ode45(f, [0, t1], u1);
[t, v2] = ode45(f, [0, t2], u2);
figure
hold on
plot(v0(:, 1), v0(:, 2), 'b', v0(1,1), v0(1,2), 'r*')
plot(v1(:, 1), v1(:, 2), 'g', v1(1,1), v1(1,2), 'r*')
plot(v2(:, 1), v2(:, 2), 'b--', v2(1,1), v2(1,2), 'r*')
title('Van der Pol')
xlabel('u(t)')
ylabel('u''(t)')
hold off
% Duffing
% u" + 0.1*u' + 1.1*u + u^3 = -3*cos(0.2*t)
% u(0) = -1, u'(0) = 0
f = @(t, u) [u(2); -0.1*u(2)-1.1*u(1)-u(1)^3-3*cos(0.2*t)];
u0 = [-1; 0];
t0 = 1000;
[t, v0] = ode45(f, [0, t0], u0);
figure
plot(v0(:, 1), v0(:, 2), 'b', v0(1,1), v0(1,2), 'r*')
% plot3(v0(:, 1), v0(:, 2), t, 'b')
title('Duffing')
xlabel('u(t)')
ylabel('u''(t)')
% Lorenz
% x' = 10(y - x)
% y' = x * (28 - z) - y
% z' = x * y - 8/3 * z
% x(0) = 1, y(0) = 2, z(0) = 3
f = @(t, u) [10*(u(2)-u(1)); u(1)*(28-u(3))-u(2); u(1)*u(2)-8/3*u(3)];
u0 = [1; 2; 3];
t0 = 100;
[t, v0] = ode45(f, [0, t0], u0);
figure
plot3(v0(:, 1), v0(:, 2), v0(:, 3), 'b', v0(1,1), v0(1,2), v0(1, 3), 'r*')
title('Lorenz')
xlabel('x(t)')
ylabel('y(t)')
zlabel('z(t)')
grid on
view([3, -2, 4])
